/**
 * Quick Comments for WordPress
 * Post comments quickly without leaving or refreshing the page.
 * @name quick-comments-0.5.1.js
 * @author wokamoto - http://dogmap.jp
 * @version 0.5.1
 * @date September 16, 2008
 * @copyright (c) 2008 wokamoto (dogmap.jp)
 * @license  Released under the GPL license (http://www.gnu.org/copyleft/gpl.html)
 * @requires jQuery v1.2.3 or later and jQuery.blockUI v2.08 or later and Interface elements for jQuery
 */

jQuery(function(){
  var qc_opt = jQuery.extend({
    form:'form#commentform'
   ,list:'ol.commentlist:first'
   ,requireNameEmail:false
   ,errMsgNameEmail:'Error: please fill the required fields (name, email).'
   ,errMsgCommentNone:'Error: please type a comment.'
   ,errMsgEmail:'Error: please enter a valid email address.'
   ,message:'wait...'
   ,message2:'loading...'
   ,loader:'ajax-loader.gif'
   ,messageCSS:{border:'1px solid #8C8C8C', font:'normal 12px Arial'}
   ,overlayCSS:{backgroundColor:'#FFF', opacity:'0.6'}
   ,effect:0
   ,speed:'fast'
   ,update:'/wp-content/plugins/quick-comments/quick-comments.php'
   ,editReturn:'#edit-comment-%ID%'
   }, quickCommentsL10n);
  var flg_ie6 = jQuery.browser.msie && jQuery.browser.version < "7.0";

  // get comment form
  var form = jQuery(qc_opt.form);
  var form_css = {position: jQuery(form).css('position')};

  // get comment list
  var list = jQuery(qc_opt.list);

  var url_insert = form.attr('action');
  var url_update = qc_opt.update;

  var default_comment = jQuery('textarea[name^=comment]', form).val();
  default_comment = (typeof default_comment == 'undefined' ? '' : default_comment);

  // Get Comment Data
  var get_comment = function(){
    form.block({
      message: '<div style="margin:0 auto;padding:0 1em 0;"><p style="margin:1.5em 0;white-space: nowrap;"><img src="' + qc_opt.loader + '" alt="loading" style="margin-right:.25em;" />' + qc_opt.message2 + '</p></div>'
     ,css: qc_opt.messageCSS
     ,overlayCSS: qc_opt.overlayCSS
    }).ScrollTo(1000, 'easeout');
    var json_url = jQuery(this).attr('href')
                 + '?json'
                 + '&comment_ID=' + jQuery(this).attr('id').replace(/^[^\d]+/, '');
    jQuery.getJSON(json_url, function(json){
      if (json.status) {
        if (jQuery('input[name^=author]', form).size() > 0) jQuery('input[name^=author]', form).val(json.author)[0].disabled = true;
        if (jQuery('input[name^=email]', form).size() > 0) jQuery('input[name^=email]', form).val(json.email)[0].disabled = true;
        if (jQuery('input[name^=url]', form).size() > 0) jQuery('input[name^=url]', form).val(json.url)[0].disabled = true;
        jQuery('textarea[name^=comment]', form).val(json.content);
        default_comment = json.content;

        if (jQuery('input#comment_ID').size() > 0) {
          jQuery('input#comment_ID').val(json.id);
        } else {
          form.append(jQuery('<input type="hidden" id="comment_ID" name="comment_ID" value="' + json.id + '" />'));
        }
        if (jQuery('input#datetime').size() > 0) {
          jQuery('input#datetime').val(json.datetime);
        } else {
          form.append(jQuery('<input type="hidden" id="datetime" name="datetime" value="' + json.datetime + '" />'));
        }
        if (jQuery('input#update').size() > 0) {
          jQuery('input#update').val('1');
        } else {
          form.append(jQuery('<input type="hidden" id="update" name="update" value="1" />'));
        }

      } else {
        alert(json.message);
      }
      form.unblock();
    });
    return false;
  }
  jQuery('a.edit-comment', list).each(function(){
    jQuery(this).unbind('click').click(get_comment);
  });

  // success
  var successCallback = function(responseText) {
    form.unblock();
    if (flg_ie6) {jQuery('legend', form).hide();}

    // Edited comment ID
    var edit_commentID = (jQuery('input#comment_ID').size() > 0 ? qc_opt.editReturn.replace('%ID%', jQuery('input#comment_ID').val()) : false);

    // Add comment list
    var list_id = (qc_opt.list).replace(/^.*[#\.]/, '').replace(/:.*$/, '');
    if (list.size() <= 0) {
      var element = (qc_opt.list).replace(/^([^#\.].*)[#\.].*$/, '$1');
      list = jQuery('<' + element + ' ' + ((/^#/).test(qc_opt.list) ? 'id' : 'class') + '="' + list_id + '"></' + element + '>');
      jQuery(qc_opt.form).prepend(list);
    }
    var body_html = responseText.replace(/[\r\n\t]/g, '').replace(/^.*<body ?[^>]*>(.*)<\/body>.*$/i, '$1');
    var comments  = jQuery(qc_opt.list, jQuery(body_html)).children();
    jQuery('a.edit-comment', comments).each(function(){
      jQuery(this).unbind('click').click(get_comment);
    });

    if (comments.length > 0) {
      if (jQuery('input#update', form).size() > 0 ) {
        // Comment Update
        list.animate({opacity:'hide'}, qc_opt.speed, function(){
          jQuery(this)
          .empty()
          .append(comments)
          .animate({opacity:'show'}, qc_opt.speed, function(){
            if (flg_ie6) {form.css(form_css); jQuery('legend', form).show();}
            if (edit_commentID != false) {jQuery(edit_commentID).ScrollTo(1000, 'easeout');}
          });
        });
      } else {
        // Comment Insert
        switch (qc_opt.effect) {
         case 1:
          comments = jQuery(jQuery.extend(comments.hide().get(), list.children().get()));
          list
          .empty()
          .append(comments)
          .children(':hidden').slideDown(qc_opt.speed, function(){
            if (flg_ie6) {form.css(form_css); jQuery('legend', form).show();}
            if (edit_commentID != false) {jQuery(edit_commentID).ScrollTo(1000, 'easeout');}
          });
          break;
         case 2:
          comments = jQuery(jQuery.extend(comments.hide().get(), list.children().get()));
          list
          .empty()
          .append(comments)
          .children(':hidden').fadeIn(qc_opt.speed, function(){
            if (flg_ie6) {form.css(form_css); jQuery('legend', form).show();}
            if (edit_commentID != false) {jQuery(edit_commentID).ScrollTo(1000, 'easeout');}
          });
          break;
         default:
          list.animate({opacity:'hide'}, qc_opt.speed, function(){
            jQuery(this)
            .empty()
            .append(comments)
            .animate({opacity:'show'}, qc_opt.speed, function(){
              if (flg_ie6) {form.css(form_css); jQuery('legend', form).show();}
            if (edit_commentID != false) {jQuery(edit_commentID).ScrollTo(1000, 'easeout');}
            });
          });
          break;
        }
      }
      jQuery('textarea[name^=comment]', form).val(''); // Reset comment

    } else {
      alert(responseText.replace(/[\r\n\t]/g, '').replace(/^.*<body ?[^>]*>(.*)<\/body>.*$/i, '$1').replace(/<[^>]*>/, ''));
    }

    jQuery('input#comment_ID').remove();
    jQuery('input#datetime').remove();
    jQuery('input#update').remove();
    jQuery('input#quick-comments').remove();
  };

  // error
  var errorCallback = function(httpRequest, status, e) {
    form.unblock();
    if (flg_ie6) {jQuery('legend', form).hide();}
    alert(httpRequest.responseText.replace(/[\r\n\t]/g, '').replace(/^.*<p>(.*?)<\/p>.*$/i, '$1'));
    if (flg_ie6) {form.css(form_css); jQuery('legend', form).show();}
  };

  // comment form AJAX submit
  form.submit(function(){
    if (jQuery('input#quick-comments', jQuery(this)).size() <= 0) {
      jQuery(this).append('<input type="hidden" name="quick-comments" id="quick-comments" value="1" />');
    }

    if (jQuery('input[name^=author]', form).size() > 0) jQuery('input[name^=author]', form).disabled = false;
    if (jQuery('input[name^=email]', form).size() > 0) jQuery('input[name^=email]', form).disabled = false;
    if (jQuery('input[name^=url]', form).size() > 0) jQuery('input[name^=url]', form).disabled = false;

    var author_name  = jQuery('input[name^=author]', form).val();
    var author_email = jQuery('input[name^=email]', form).val();
    var comment_text = jQuery('textarea[name^=comment]', form).val();

    author_name  = (typeof author_name == 'undefined'  ? '' : author_name);
    author_email = (typeof author_email == 'undefined' ? '' : author_email);
    comment_text = (typeof comment_text == 'undefined' ? '' : comment_text);

    // require Name & Email
    if (qc_opt.requireNameEmail && (author_name == "" || author_email  == "")) {
      alert (qc_opt.errMsgNameEmail);
      return false;
    }

    // valid Email ?
    if (author_email != "" && !(/^([a-z0-9+_]|\-|\.)+@(([a-z0-9_]|\-)+\.)+[a-z]{2,6}$/).test(author_email)) {
      alert (qc_opt.errMsgEmail);
      return false;
    }

    // type Comment ?
    if (comment_text == "" || comment_text == default_comment) {
      alert (qc_opt.errMsgCommentNone);
      return false;
    }

    var url = ( jQuery('input#update').size() > 0 ? url_update : url_insert );
    var param = jQuery('input, textarea', jQuery(this)).serialize();

    //this.submit.disabled = true; // disable submit
    jQuery(this).block({
      message: '<div style="margin:0 auto;padding:0 1em 0;"><p style="margin:1.5em 0;white-space: nowrap;"><img src="' + qc_opt.loader + '" alt="loading" style="margin-right:.25em;" />' + qc_opt.message + '</p></div>'
     ,css: qc_opt.messageCSS
     ,overlayCSS: qc_opt.overlayCSS
    })

    jQuery.ajax({
      type:    "POST"
     ,cache:   false
     ,url:     url
     ,data:    param
     ,success: successCallback
     ,error:   errorCallback
    });

    return false;
   });

});
